﻿
namespace Subkismet.Waegis.Client.Components
{
    /// <summary>
    /// Represents the response returned from the Waegis API
    /// </summary>
    public class ServiceResult
    {
        #region Properties

        /// <summary>
        /// The status of the response
        /// </summary>
        public ResultStatus Status { get; set; }

        /// <summary>
        /// The message
        /// </summary>
        public string Message { get; set; }

        #endregion

        #region Public Constructors

        /// <summary>
        /// Public constructor
        /// </summary>
        public ServiceResult()
        {
        }

        /// <summary>
        /// Public constructor
        /// </summary>
        /// <param name="status">The status of the response</param>
        /// <param name="message">The message</param>
        public ServiceResult(ResultStatus status, string message)
        {
            this.Status = status;
            this.Message = message;
        }

        #endregion
    }
}
